diff -upr ioquake3svn1438/code/ui/ui_main.c ioquake3serverFix/code/ui/ui_main.c
--- ioquake3svn1438/code/ui/ui_main.c	2008-06-22 03:28:43.000000000 -0500
+++ ioquake3serverFix/code/ui/ui_main.c	2008-08-09 11:28:23.000000000 -0500
@@ -64,7 +64,7 @@ static const int numNetSources = sizeof(
 
 static const serverFilter_t serverFilters[] = {
 	{"All", "" },
-	{"OpenArena", "" },
+	{"Quake 3 Arena", "" },
 	{"Team Arena", "missionpack" },
 	{"Rocket Arena", "arena" },
 	{"Alliance", "alliance20" },
@@ -81,11 +81,7 @@ static const char *teamArenaGameTypes[] 
 	"1FCTF",
 	"OVERLOAD",
 	"HARVESTER",
-	"TEAMTOURNAMENT",
-	"ELIMINATION",
-	"CTFELIMINATION",
-	"LMS",
-	"DD"
+	"TEAMTOURNAMENT"
 };
 
 static int const numTeamArenaGameTypes = sizeof(teamArenaGameTypes) / sizeof(const char*);
@@ -101,10 +97,6 @@ static const char *teamArenaGameNames[] 
 	"Overload",
 	"Harvester",
 	"Team Tournament",
-	"Elimination",
-	"CTF Elimination",
-	"Last Man Standing",
-	"Double Domination"
 };
 
 static int const numTeamArenaGameNames = sizeof(teamArenaGameNames) / sizeof(const char*);
@@ -127,8 +119,8 @@ static char* netnames[] = {
 	NULL
 };
 
-#ifndef MISSIONPACK // bk001206
-static char quake3worldMessage[] = "Visit www.openarena.ws - News, Community, Events, Files";
+#ifndef MISSIONPACK
+static char quake3worldMessage[] = "Visit www.quake3world.com - News, Community, Events, Files";
 #endif
 
 static int gamecodetoui[] = {4,2,3,0,5,1,6};
@@ -211,7 +203,7 @@ intptr_t vmMain( int command, int arg0, 
 		  UI_DrawConnectScreen( arg0 );
 		  return 0;
 	  case UI_HASUNIQUECDKEY: // mod authors need to observe this
-	    return qtrue; // bk010117 - change this to qfalse for mods!
+	    return qtrue; // change this to qfalse for mods!
 
 	}
 
@@ -320,7 +312,7 @@ int Text_Height(const char *text, float 
 	float max;
 	glyphInfo_t *glyph;
 	float useScale;
-	const char *s = text; // bk001206 - unsigned
+	const char *s = text;
 	fontInfo_t *font = &uiInfo.uiDC.Assets.textFont;
 	if (scale <= ui_smallFont.value) {
 		font = &uiInfo.uiDC.Assets.smallFont;
@@ -373,7 +365,7 @@ void Text_Paint(float x, float y, float 
 	}
 	useScale = scale * font->glyphScale;
   if (text) {
-    const char *s = text; // bk001206 - unsigned
+    const char *s = text;
 		trap_R_SetColor( color );
 		memcpy(&newColor[0], &color[0], sizeof(vec4_t));
     len = strlen(text);
@@ -442,7 +434,7 @@ void Text_PaintWithCursor(float x, float
 	}
 	useScale = scale * font->glyphScale;
   if (text) {
-    const char *s = text; // bk001206 - unsigned
+    const char *s = text;
 		trap_R_SetColor( color );
 		memcpy(&newColor[0], &color[0], sizeof(vec4_t));
     len = strlen(text);
@@ -450,7 +442,7 @@ void Text_PaintWithCursor(float x, float
 			len = limit;
 		}
 		count = 0;
-		glyph2 = &font->glyphs[ (int) cursor]; // bk001206 - possible signed char
+		glyph2 = &font->glyphs[ (int) cursor];
 		while (s && *s && count < len) {
 			glyph = &font->glyphs[(int)*s]; // TTimo: FIXME: getting nasty warnings without the cast, hopefully this doesn't break the VM build
       //int yadj = Assets.textFont.glyphs[text[i]].bottom + Assets.textFont.glyphs[text[i]].top;
@@ -532,7 +524,7 @@ static void Text_Paint_Limit(float *maxX
 	vec4_t newColor;
 	glyphInfo_t *glyph;
   if (text) {
-    const char *s = text; // bk001206 - unsigned
+    const char *s = text;
 		float max = *maxX;
 		float useScale;
 		fontInfo_t *font = &uiInfo.uiDC.Assets.textFont;
@@ -1014,7 +1006,7 @@ void UI_Load(void) {
 }
 
 static const char *handicapValues[] = {"None","95","90","85","80","75","70","65","60","55","50","45","40","35","30","25","20","15","10","5",NULL};
-#ifndef MISSIONPACK // bk001206
+#ifndef MISSIONPACK
 static int numHandicaps = sizeof(handicapValues) / sizeof(const char*);
 #endif
 
@@ -1419,7 +1411,7 @@ static void UI_DrawTierGameType(rectDef_
 }
 
 
-#ifndef MISSIONPACK // bk001206
+#ifndef MISSIONPACK
 static const char *UI_OpponentLeaderName(void) {
   int i = UI_TeamIndexFromName(UI_Cvar_VariableString("ui_opponentName"));
 	return uiInfo.teamList[i].teamMembers[0];
@@ -1433,10 +1425,10 @@ static const char *UI_AIFromName(const c
 			return uiInfo.aliasList[j].ai;
 		}
 	}
-	return "sergei";
+	return "James";
 }
 
-#ifndef MISSIONPACK // bk001206
+#ifndef MISSIONPACK
 static const int UI_AIIndex(const char *name) {
 	int j;
 	for (j = 0; j < uiInfo.characterCount; j++) {
@@ -1448,7 +1440,7 @@ static const int UI_AIIndex(const char *
 }
 #endif
 
-#ifndef MISSIONPACK // bk001206
+#ifndef MISSIONPACK
 static const int UI_AIIndexFromName(const char *name) {
 	int j;
 	for (j = 0; j < uiInfo.aliasCount; j++) {
@@ -1461,14 +1453,14 @@ static const int UI_AIIndexFromName(cons
 #endif
 
 
-#ifndef MISSIONPACK // bk001206
+#ifndef MISSIONPACK
 static const char *UI_OpponentLeaderHead(void) {
 	const char *leader = UI_OpponentLeaderName();
 	return UI_AIFromName(leader);
 }
 #endif
 
-#ifndef MISSIONPACK // bk001206
+#ifndef MISSIONPACK
 static const char *UI_OpponentLeaderModel(void) {
 	int i;
 	const char *head = UI_OpponentLeaderHead();
@@ -1477,7 +1469,7 @@ static const char *UI_OpponentLeaderMode
 			return uiInfo.characterList[i].base;
 		}
 	}
-	return "sergei";
+	return "James";
 }
 #endif
 
@@ -1755,7 +1747,7 @@ static void UI_DrawBotName(rectDef_t *re
 	int value = uiInfo.botIndex;
 	int game = trap_Cvar_VariableValue("g_gametype");
 	const char *text = "";
-	if (game >= GT_TEAM && !GT_LMS ) {
+	if (game >= GT_TEAM) {
 		if (value >= uiInfo.characterCount) {
 			value = 0;
 		}
@@ -2156,14 +2148,14 @@ static qboolean UI_OwnerDrawVisible(int 
 	while (flags) {
 
 		if (flags & UI_SHOW_FFA) {
-			if (trap_Cvar_VariableValue("g_gametype") != GT_FFA || trap_Cvar_VariableValue("g_gametype") != GT_LMS ) {
+			if (trap_Cvar_VariableValue("g_gametype") != GT_FFA) {
 				vis = qfalse;
 			}
 			flags &= ~UI_SHOW_FFA;
 		}
 
 		if (flags & UI_SHOW_NOTFFA) {
-			if (trap_Cvar_VariableValue("g_gametype") == GT_FFA || trap_Cvar_VariableValue("g_gametype") == GT_LMS ) {
+			if (trap_Cvar_VariableValue("g_gametype") == GT_FFA) {
 				vis = qfalse;
 			}
 			flags &= ~UI_SHOW_NOTFFA;
@@ -2207,25 +2199,25 @@ static qboolean UI_OwnerDrawVisible(int 
 			flags &= ~UI_SHOW_NOTFAVORITESERVERS;
 		} 
 		if (flags & UI_SHOW_ANYTEAMGAME) {
-			if (uiInfo.gameTypes[ui_gameType.integer].gtEnum <= GT_TEAM && uiInfo.gameTypes[ui_gameType.integer].gtEnum != GT_LMS ) {
+			if (uiInfo.gameTypes[ui_gameType.integer].gtEnum <= GT_TEAM ) {
 				vis = qfalse;
 			}
 			flags &= ~UI_SHOW_ANYTEAMGAME;
 		} 
 		if (flags & UI_SHOW_ANYNONTEAMGAME) {
-			if (uiInfo.gameTypes[ui_gameType.integer].gtEnum > GT_TEAM || uiInfo.gameTypes[ui_gameType.integer].gtEnum == GT_LMS ) {
+			if (uiInfo.gameTypes[ui_gameType.integer].gtEnum > GT_TEAM ) {
 				vis = qfalse;
 			}
 			flags &= ~UI_SHOW_ANYNONTEAMGAME;
 		} 
 		if (flags & UI_SHOW_NETANYTEAMGAME) {
-			if (uiInfo.gameTypes[ui_netGameType.integer].gtEnum <= GT_TEAM && uiInfo.gameTypes[ui_gameType.integer].gtEnum != GT_LMS ) {
+			if (uiInfo.gameTypes[ui_netGameType.integer].gtEnum <= GT_TEAM ) {
 				vis = qfalse;
 			}
 			flags &= ~UI_SHOW_NETANYTEAMGAME;
 		} 
 		if (flags & UI_SHOW_NETANYNONTEAMGAME) {
-			if (uiInfo.gameTypes[ui_netGameType.integer].gtEnum > GT_TEAM || uiInfo.gameTypes[ui_gameType.integer].gtEnum == GT_LMS ) {
+			if (uiInfo.gameTypes[ui_netGameType.integer].gtEnum > GT_TEAM ) {
 				vis = qfalse;
 			}
 			flags &= ~UI_SHOW_NETANYNONTEAMGAME;
@@ -2503,12 +2495,8 @@ static qboolean UI_NetSource_HandleKey(i
 		
 		if (key == K_MOUSE2) {
 			ui_netSource.integer--;
-			if (ui_netSource.integer == AS_MPLAYER)
-				ui_netSource.integer--;
 		} else {
 			ui_netSource.integer++;
-			if (ui_netSource.integer == AS_MPLAYER)
-				ui_netSource.integer++;
 		}
     
 		if (ui_netSource.integer >= numNetSources) {
@@ -2570,7 +2558,7 @@ static qboolean UI_BotName_HandleKey(int
 			value++;
 		}
 
-		if (game >= GT_TEAM && !GT_LMS) {
+		if (game >= GT_TEAM) {
 			if (value >= uiInfo.characterCount + 2) {
 				value = 0;
 			} else if (value < 0) {
@@ -3172,7 +3160,7 @@ static void UI_RunMenuScript(char **args
 			trap_Cvar_Set("cg_cameraOrbit", "0");
 			trap_Cvar_Set("ui_singlePlayerActive", "0");
 			trap_Cvar_SetValue( "dedicated", Com_Clamp( 0, 2, ui_dedicated.integer ) );
-			trap_Cvar_SetValue( "g_gametype", Com_Clamp( 0, 13, uiInfo.gameTypes[ui_netGameType.integer].gtEnum ) );
+			trap_Cvar_SetValue( "g_gametype", Com_Clamp( 0, 8, uiInfo.gameTypes[ui_netGameType.integer].gtEnum ) );
 			trap_Cvar_Set("g_redTeam", UI_Cvar_VariableString("ui_teamName"));
 			trap_Cvar_Set("g_blueTeam", UI_Cvar_VariableString("ui_opponentName"));
 			trap_Cmd_ExecuteText( EXEC_APPEND, va( "wait ; wait ; map %s\n", uiInfo.mapList[ui_currentNetMap.integer].mapLoadName ) );
@@ -3409,7 +3397,7 @@ static void UI_RunMenuScript(char **args
 				trap_Cmd_ExecuteText( EXEC_APPEND, va("callteamvote leader %s\n",uiInfo.teamNames[uiInfo.teamIndex]) );
 			}
 		} else if (Q_stricmp(name, "addBot") == 0) {
-			if (trap_Cvar_VariableValue("g_gametype") >= GT_TEAM && !GT_LMS ) {
+			if (trap_Cvar_VariableValue("g_gametype") >= GT_TEAM) {
 				trap_Cmd_ExecuteText( EXEC_APPEND, va("addbot %s %i %s\n", uiInfo.characterList[uiInfo.botIndex].name, uiInfo.skillIndex+1, (uiInfo.redBlue == 0) ? "Red" : "Blue") );
 			} else {
 				trap_Cmd_ExecuteText( EXEC_APPEND, va("addbot %s %i %s\n", UI_GetBotNameByNumber(uiInfo.botIndex), uiInfo.skillIndex+1, (uiInfo.redBlue == 0) ? "Red" : "Blue") );
@@ -4598,9 +4586,9 @@ static qboolean Character_Parse(char **p
 			uiInfo.characterList[uiInfo.characterCount].imageName = String_Alloc(va("models/players/heads/%s/icon_default.tga", uiInfo.characterList[uiInfo.characterCount].name));
 
 	  if (tempStr && (!Q_stricmp(tempStr, "female"))) {
-        uiInfo.characterList[uiInfo.characterCount].base = String_Alloc(va("kyonshi"));
+        uiInfo.characterList[uiInfo.characterCount].base = String_Alloc(va("Janet"));
       } else if (tempStr && (!Q_stricmp(tempStr, "male"))) {
-        uiInfo.characterList[uiInfo.characterCount].base = String_Alloc(va("sergei"));
+        uiInfo.characterList[uiInfo.characterCount].base = String_Alloc(va("James"));
 	  } else {
         uiInfo.characterList[uiInfo.characterCount].base = String_Alloc(va("%s",tempStr));
 	  }
@@ -4904,9 +4892,8 @@ static void UI_Pause(qboolean b) {
 	}
 }
 
-#ifndef MISSIONPACK // bk001206
+#ifndef MISSIONPACK
 static int UI_OwnerDraw_Width(int ownerDraw) {
-  // bk001205 - LCC missing return value
   return 0;
 }
 #endif
@@ -5013,7 +5000,7 @@ static void UI_BuildQ3Model_List( void )
 				}
 				if (!dirty) {
 					Com_sprintf( uiInfo.q3HeadNames[uiInfo.q3HeadCount], sizeof(uiInfo.q3HeadNames[uiInfo.q3HeadCount]), "%s", scratch);
-                                    uiInfo.q3HeadIcons[uiInfo.q3HeadCount++] = trap_R_RegisterShaderNoMip(va("models/players/%s/%s",dirptr,skinname));
+					uiInfo.q3HeadIcons[uiInfo.q3HeadCount++] = trap_R_RegisterShaderNoMip(va("models/players/%s/%s",dirptr,skinname));
 				}
 			}
 
@@ -5138,7 +5125,7 @@ void _UI_Init( qboolean inGameLoad ) {
 #if 0
 	if (uiInfo.inGameLoad) {
 		UI_LoadMenus("ui/ingame.txt", qtrue);
-	} else { // bk010222: left this: UI_LoadMenus(menuSet, qtrue);
+	} else {
 	}
 #else 
 	UI_LoadMenus(menuSet, qtrue);
@@ -5432,8 +5419,8 @@ static void UI_DisplayDownloadInfo( cons
 	Text_PaintCenter(centerPoint, yStart + 248, scale, colorWhite, xferText, 0);
 
 	if (downloadSize > 0) {
- 		s = va( "%s (%d%%)", downloadName,
- 			(int)( (float)downloadCount * 100.0f / downloadSize ) );
+		s = va( "%s (%d%%)", downloadName,
+			(int)( (float)downloadCount * 100.0f / downloadSize ) );
 	} else {
 		s = downloadName;
 	}
@@ -5705,8 +5692,6 @@ vmCvar_t	ui_realCaptureLimit;
 vmCvar_t	ui_realWarmUp;
 vmCvar_t	ui_serverStatusTimeOut;
 
-
-// bk001129 - made static to avoid aliasing
 static cvarTable_t		cvarTable[] = {
 	{ &ui_ffa_fraglimit, "ui_ffa_fraglimit", "20", CVAR_ARCHIVE },
 	{ &ui_ffa_timelimit, "ui_ffa_timelimit", "0", CVAR_ARCHIVE },
@@ -5829,7 +5814,6 @@ static cvarTable_t		cvarTable[] = {
 
 };
 
-// bk001129 - made static to avoid aliasing
 static int		cvarTableSize = sizeof(cvarTable) / sizeof(cvarTable[0]);
 
 
@@ -5893,7 +5877,7 @@ static void UI_StopServerRefresh( void )
 ArenaServers_MaxPing
 =================
 */
-#ifndef MISSIONPACK // bk001206
+#ifndef MISSIONPACK
 static int ArenaServers_MaxPing( void ) {
 	int		maxPing;
 
@@ -5955,7 +5939,6 @@ UI_StartServerRefresh
 */
 static void UI_StartServerRefresh(qboolean full)
 {
-	int		i;
 	char	*ptr;
 
 	qtime_t q;
@@ -5984,20 +5967,14 @@ static void UI_StartServerRefresh(qboole
 	}
 
 	uiInfo.serverStatus.refreshtime = uiInfo.uiDC.realTime + 5000;
-	if( ui_netSource.integer == AS_GLOBAL || ui_netSource.integer == AS_MPLAYER ) {
-		if( ui_netSource.integer == AS_GLOBAL ) {
-			i = 0;
-		}
-		else {
-			i = 1;
-		}
+	if( ui_netSource.integer == AS_GLOBAL ) {
 
 		ptr = UI_Cvar_VariableString("debug_protocol");
 		if (strlen(ptr)) {
-			trap_Cmd_ExecuteText( EXEC_NOW, va( "globalservers %d %s full empty\n", i, ptr));
+			trap_Cmd_ExecuteText( EXEC_NOW, va( "globalservers 0 %s full empty\n", ptr));
 		}
 		else {
-			trap_Cmd_ExecuteText( EXEC_NOW, va( "globalservers %d %d full empty\n", i, (int)trap_Cvar_VariableValue( "protocol" ) ) );
+			trap_Cmd_ExecuteText( EXEC_NOW, va( "globalservers 0 %d full empty\n", (int)trap_Cvar_VariableValue( "protocol" ) ) );
 		}
 	}
 }
Only in ioquake3svn1438/code/ui: ui.q3asm
diff -upr ioquake3svn1438/code/ui/ui_shared.c ioquake3serverFix/code/ui/ui_shared.c
--- ioquake3svn1438/code/ui/ui_shared.c	2008-06-22 03:28:43.000000000 -0500
+++ ioquake3serverFix/code/ui/ui_shared.c	2008-08-09 11:28:23.000000000 -0500
@@ -534,7 +534,7 @@ qboolean PC_Script_Parse(int handle, con
 		}
 		Q_strcat(script, 1024, " ");
 	}
-	return qfalse; 	// bk001105 - LCC   missing return value
+	return qfalse;
 }
 
 // display, window, menu, item code
@@ -1342,13 +1342,13 @@ qboolean Item_SetFocus(itemDef_t *item, 
 	itemDef_t *oldFocus;
 	sfxHandle_t *sfx = &DC->Assets.itemFocusSound;
 	qboolean playSound = qfalse;
-	menuDef_t *parent; // bk001206: = (menuDef_t*)item->parent;
+	menuDef_t *parent;
 	// sanity check, non-null, not a decoration and does not already have the focus
 	if (item == NULL || item->window.flags & WINDOW_DECORATION || item->window.flags & WINDOW_HASFOCUS || !(item->window.flags & WINDOW_VISIBLE)) {
 		return qfalse;
 	}
 
-	// bk001206 - this can be NULL.
+	// this can be NULL
 	parent = (menuDef_t*)item->parent; 
       
 	// items can be enabled and disabled based on cvars
@@ -1727,7 +1727,7 @@ qboolean Item_ListBox_HandleKey(itemDef_
 		max = Item_ListBox_MaxScroll(item);
 		if (item->window.flags & WINDOW_HORIZONTAL) {
 			viewmax = (item->window.rect.w / listPtr->elementWidth);
-			if ( key == K_LEFTARROW ) 
+			if ( key == K_LEFTARROW || key == K_KP_LEFTARROW ) 
 			{
 				if (!listPtr->notselectable) {
 					listPtr->cursorPos--;
@@ -1750,7 +1750,7 @@ qboolean Item_ListBox_HandleKey(itemDef_
 				}
 				return qtrue;
 			}
-			if ( key == K_RIGHTARROW ) 
+			if ( key == K_RIGHTARROW || key == K_KP_RIGHTARROW ) 
 			{
 				if (!listPtr->notselectable) {
 					listPtr->cursorPos++;
@@ -1776,7 +1776,7 @@ qboolean Item_ListBox_HandleKey(itemDef_
 		}
 		else {
 			viewmax = (item->window.rect.h / listPtr->elementHeight);
-			if ( key == K_UPARROW ) 
+			if ( key == K_UPARROW || key == K_KP_UPARROW ) 
 			{
 				if (!listPtr->notselectable) {
 					listPtr->cursorPos--;
@@ -1799,7 +1799,7 @@ qboolean Item_ListBox_HandleKey(itemDef_
 				}
 				return qtrue;
 			}
-			if ( key == K_DOWNARROW ) 
+			if ( key == K_DOWNARROW || key == K_KP_DOWNARROW ) 
 			{
 				if (!listPtr->notselectable) {
 					listPtr->cursorPos++;
@@ -1863,17 +1863,17 @@ qboolean Item_ListBox_HandleKey(itemDef_
 			}
 			return qtrue;
 		}
-		if ( key == K_HOME ) {
+		if ( key == K_HOME || key == K_KP_HOME) {
 			// home
 			listPtr->startPos = 0;
 			return qtrue;
 		}
-		if ( key == K_END ) {
+		if ( key == K_END || key == K_KP_END) {
 			// end
 			listPtr->startPos = max;
 			return qtrue;
 		}
-		if (key == K_PGUP ) {
+		if (key == K_PGUP || key == K_KP_PGUP ) {
 			// page up
 			if (!listPtr->notselectable) {
 				listPtr->cursorPos -= viewmax;
@@ -1897,7 +1897,7 @@ qboolean Item_ListBox_HandleKey(itemDef_
 			}
 			return qtrue;
 		}
-		if ( key == K_PGDN ) {
+		if ( key == K_PGDN || key == K_KP_PGDN ) {
 			// page down
 			if (!listPtr->notselectable) {
 				listPtr->cursorPos += viewmax;
@@ -2094,7 +2094,7 @@ qboolean Item_TextField_HandleKey(itemDe
 
 		} else {
 
-			if ( key == K_DEL ) {
+			if ( key == K_DEL || key == K_KP_DEL ) {
 				if ( item->cursorPos < len ) {
 					memmove( buff + item->cursorPos, buff + item->cursorPos + 1, len - item->cursorPos);
 					DC->setCVar(item->cvar, buff);
@@ -2102,7 +2102,7 @@ qboolean Item_TextField_HandleKey(itemDe
 				return qtrue;
 			}
 
-			if ( key == K_RIGHTARROW ) 
+			if ( key == K_RIGHTARROW || key == K_KP_RIGHTARROW ) 
 			{
 				if (editPtr->maxPaintChars && item->cursorPos >= editPtr->maxPaintChars && item->cursorPos < len) {
 					item->cursorPos++;
@@ -2115,7 +2115,7 @@ qboolean Item_TextField_HandleKey(itemDe
 				return qtrue;
 			}
 
-			if ( key == K_LEFTARROW ) 
+			if ( key == K_LEFTARROW || key == K_KP_LEFTARROW ) 
 			{
 				if ( item->cursorPos > 0 ) {
 					item->cursorPos--;
@@ -2126,13 +2126,13 @@ qboolean Item_TextField_HandleKey(itemDe
 				return qtrue;
 			}
 
-			if ( key == K_HOME ) {// || ( tolower(key) == 'a' && trap_Key_IsDown( K_CTRL ) ) ) {
+			if ( key == K_HOME || key == K_KP_HOME) {// || ( tolower(key) == 'a' && trap_Key_IsDown( K_CTRL ) ) ) {
 				item->cursorPos = 0;
 				editPtr->paintOffset = 0;
 				return qtrue;
 			}
 
-			if ( key == K_END )  {// ( tolower(key) == 'e' && trap_Key_IsDown( K_CTRL ) ) ) {
+			if ( key == K_END || key == K_KP_END)  {// ( tolower(key) == 'e' && trap_Key_IsDown( K_CTRL ) ) ) {
 				item->cursorPos = len;
 				if(item->cursorPos > editPtr->maxPaintChars) {
 					editPtr->paintOffset = len - editPtr->maxPaintChars;
@@ -2140,20 +2140,20 @@ qboolean Item_TextField_HandleKey(itemDe
 				return qtrue;
 			}
 
-			if ( key == K_INS ) {
+			if ( key == K_INS || key == K_KP_INS ) {
 				DC->setOverstrikeMode(!DC->getOverstrikeMode());
 				return qtrue;
 			}
 		}
 
-		if (key == K_TAB || key == K_DOWNARROW ) {
+		if (key == K_TAB || key == K_DOWNARROW || key == K_KP_DOWNARROW) {
 			newItem = Menu_SetNextCursorItem(item->parent);
 			if (newItem && (newItem->type == ITEM_TYPE_EDITFIELD || newItem->type == ITEM_TYPE_NUMERICFIELD)) {
 				g_editItem = newItem;
 			}
 		}
 
-		if (key == K_UPARROW ) {
+		if (key == K_UPARROW || key == K_KP_UPARROW) {
 			newItem = Menu_SetPrevCursorItem(item->parent);
 			if (newItem && (newItem->type == ITEM_TYPE_EDITFIELD || newItem->type == ITEM_TYPE_NUMERICFIELD)) {
 				g_editItem = newItem;
@@ -2374,7 +2374,6 @@ qboolean Item_HandleKey(itemDef_t *item,
 		captureFunc = 0;
 		captureData = NULL;
 	} else {
-	  // bk001206 - parentheses
 		if ( down && ( key == K_MOUSE1 || key == K_MOUSE2 || key == K_MOUSE3 ) ) {
 			Item_StartCapture(item, key);
 		}
@@ -2629,7 +2628,6 @@ void Menu_HandleKey(menuDef_t *menu, int
 		// see if the mouse is within the window bounds and if so is this a mouse click
 	if (down && !(menu->window.flags & WINDOW_POPUP) && !Rect_ContainsPoint(&menu->window.rect, DC->cursorx, DC->cursory)) {
 		static qboolean inHandleKey = qfalse;
-		// bk001206 - parentheses
 		if (!inHandleKey && ( key == K_MOUSE1 || key == K_MOUSE2 || key == K_MOUSE3 ) ) {
 			inHandleKey = qtrue;
 			Menus_HandleOOBClick(menu, key, down);
@@ -2673,6 +2671,7 @@ void Menu_HandleKey(menuDef_t *menu, int
 				DC->executeText(EXEC_APPEND, "screenshot\n");
 			}
 			break;
+		case K_KP_UPARROW:
 		case K_UPARROW:
 			Menu_SetPrevCursorItem(menu);
 			break;
@@ -2685,6 +2684,7 @@ void Menu_HandleKey(menuDef_t *menu, int
 			}
 			break;
 		case K_TAB:
+		case K_KP_DOWNARROW:
 		case K_DOWNARROW:
 			Menu_SetNextCursorItem(menu);
 			break;
@@ -3186,7 +3186,6 @@ static bind_t g_bindings[] = 
 	{"tauntGauntlet", K_F5,			-1,		-1, -1},
 	{"scoresUp", K_KP_PGUP,			-1,		-1, -1},
 	{"scoresDown", K_KP_PGDN,			-1,		-1, -1},
-	// bk001205 - this one below was:  '-1' 
 	{"messagemode",  -1,					-1,		-1, -1},
 	{"messagemode2", -1,						-1,		-1, -1},
 	{"messagemode3", -1,						-1,		-1, -1},
@@ -3196,7 +3195,7 @@ static bind_t g_bindings[] = 
 
 static const int g_bindCount = sizeof(g_bindings) / sizeof(bind_t);
 
-#ifndef MISSIONPACK // bk001206
+#ifndef MISSIONPACK
 static configcvar_t g_configcvars[] =
 {
 	{"cl_run",			0,					0},
@@ -4962,7 +4961,7 @@ qboolean ItemParse_cvarStrList( itemDef_
 		}
 
 	}
-	return qfalse; 	// bk001205 - LCC missing return value
+	return qfalse;
 }
 
 qboolean ItemParse_cvarFloatList( itemDef_t *item, int handle ) {
@@ -5007,7 +5006,7 @@ qboolean ItemParse_cvarFloatList( itemDe
 		}
 
 	}
-	return qfalse; 	// bk001205 - LCC missing return value
+	return qfalse;
 }
 
 
@@ -5186,7 +5185,7 @@ qboolean Item_Parse(int handle, itemDef_
 			return qfalse;
 		}
 	}
-	return qfalse; 	// bk001205 - LCC missing return value
+	return qfalse;
 }
 
 
@@ -5240,7 +5239,7 @@ qboolean MenuParse_name( itemDef_t *item
 
 qboolean MenuParse_fullscreen( itemDef_t *item, int handle ) {
 	menuDef_t *menu = (menuDef_t*)item;
-	if (!PC_Int_Parse(handle, (int*) &menu->fullScreen)) { // bk001206 - cast qboolean
+	if (!PC_Int_Parse(handle, (int*) &menu->fullScreen)) {
 		return qfalse;
 	}
 	return qtrue;
@@ -5589,7 +5588,7 @@ qboolean Menu_Parse(int handle, menuDef_
 			return qfalse;
 		}
 	}
-	return qfalse; 	// bk001205 - LCC missing return value
+	return qfalse;
 }
 
 /*
@@ -5637,7 +5636,7 @@ displayContextDef_t *Display_GetContext(
 	return DC;
 }
  
-#ifndef MISSIONPACK // bk001206
+#ifndef MISSIONPACK
 static float captureX;
 static float captureY;
 #endif
diff -upr ioquake3svn1438/code/ui/ui_shared.h ioquake3serverFix/code/ui/ui_shared.h
--- ioquake3svn1438/code/ui/ui_shared.h	2008-08-03 12:55:25.000000000 -0500
+++ ioquake3serverFix/code/ui/ui_shared.h	2008-08-09 11:28:23.000000000 -0500
@@ -103,7 +103,7 @@ Foundation, Inc., 51 Franklin St, Fifth 
 #define SLIDER_HEIGHT 16.0
 #define SLIDER_THUMB_WIDTH 12.0
 #define SLIDER_THUMB_HEIGHT 20.0
-#define	NUM_CROSSHAIRS			99
+#define	NUM_CROSSHAIRS			10
 
 typedef struct {
   const char *command;
diff -upr ioquake3svn1438/Makefile ioquake3serverFix/Makefile
--- ioquake3svn1438/Makefile	2008-08-06 16:52:08.000000000 -0500
+++ ioquake3serverFix/Makefile	2008-08-09 15:22:37.000000000 -0500
@@ -257,14 +257,14 @@ ifeq ($(PLATFORM),linux)
   ifeq ($(ARCH),x86_64)
     OPTIMIZE = -O3 -fomit-frame-pointer -ffast-math -funroll-loops \
       -falign-loops=2 -falign-jumps=2 -falign-functions=2 \
-      -fstrength-reduce -fstack-protector -D_FORTIFY_SOURCE=2
+      -fstrength-reduce
     # experimental x86_64 jit compiler! you need GNU as
     HAVE_VM_COMPILED = true
   else
   ifeq ($(ARCH),i386)
-    OPTIMIZE = -O3 -mtune=generic -fomit-frame-pointer -ffast-math \
+    OPTIMIZE = -O3 -mtune=athlon-xp -fomit-frame-pointer -ffast-math \
       -funroll-loops -falign-loops=2 -falign-jumps=2 \
-      -falign-functions=2 -fstrength-reduce -fstack-protector -D_FORTIFY_SOURCE=2
+      -falign-functions=2 -fstrength-reduce
     HAVE_VM_COMPILED=true
   else
   ifeq ($(ARCH),ppc)
@@ -430,7 +430,7 @@ ifeq ($(PLATFORM),mingw32)
   # require XP. In theory this restriction can be removed if this header is
   # obtained separately from the platform SDK. The MSVC build does not have
   # this limitation.
-  #BASE_CFLAGS += -DWINVER=0x501
+  BASE_CFLAGS += -DWINVER=0x501
 
   ifeq ($(USE_OPENAL),1)
     BASE_CFLAGS += -DUSE_OPENAL
@@ -1613,7 +1613,6 @@ Q3CGOBJ_ = \
   $(B)/baseoa/cgame/cg_scoreboard.o \
   $(B)/baseoa/cgame/cg_servercmds.o \
   $(B)/baseoa/cgame/cg_snapshot.o \
-  $(B)/baseoa/cgame/cg_unlagged.o \
   $(B)/baseoa/cgame/cg_view.o \
   $(B)/baseoa/cgame/cg_weapons.o \
   \
@@ -1657,7 +1656,6 @@ MPCGOBJ_ = \
   $(B)/missionpack/cgame/cg_scoreboard.o \
   $(B)/missionpack/cgame/cg_servercmds.o \
   $(B)/missionpack/cgame/cg_snapshot.o \
-  $(B)/missionpack/cgame/cg_unlagged.o \
   $(B)/missionpack/cgame/cg_view.o \
   $(B)/missionpack/cgame/cg_weapons.o \
   $(B)/missionpack/ui/ui_shared.o \
@@ -1712,7 +1710,6 @@ Q3GOBJ_ = \
   $(B)/baseoa/game/g_target.o \
   $(B)/baseoa/game/g_team.o \
   $(B)/baseoa/game/g_trigger.o \
-  $(B)/baseoa/game/g_unlagged.o \
   $(B)/baseoa/game/g_utils.o \
   $(B)/baseoa/game/g_weapon.o \
   \
@@ -1764,7 +1761,6 @@ MPGOBJ_ = \
   $(B)/missionpack/game/g_target.o \
   $(B)/missionpack/game/g_team.o \
   $(B)/missionpack/game/g_trigger.o \
-  $(B)/missionpack/game/g_unlagged.o \
   $(B)/missionpack/game/g_utils.o \
   $(B)/missionpack/game/g_weapon.o \
   \
Only in ioquake3serverFix: Makefile.orig
Only in ioquake3serverFix/misc: sdl-win32-mouse-fixes.diff
diff -upr ioquake3svn1438/README ioquake3serverFix/README
--- ioquake3svn1438/README	2008-07-23 12:10:57.000000000 -0500
+++ ioquake3serverFix/README	2008-08-09 11:28:24.000000000 -0500
@@ -174,6 +174,8 @@ New cvars
                                       See also
                                       http://wiki.ioquake3.org/Stereo_Rendering
                                       for more information
+  r_sdlDriver                       - read only, indicates the SDL driver
+                                      backend being used
 
 New commands
   video [filename]        - start video capture (use with demo command)
@@ -391,6 +393,26 @@ SDL Keyboard Differences
   annoying to use on many non-US keyboards.  In response, an additional
   toggleConsole bind has been added on the key combination Shift-Esc.
 
+Mouse Input On Windows
+  ioq3 uses SDL to abstract away as much as possible from platform specific
+  implementation details. Unfortunately, SDL 1.2 suffers from a number of bugs
+  and limitations with respect to mouse input on the Windows platform. We
+  provide a patch against the SDL subversion 1.2 branch which fixes the
+  following problems:
+
+    * DirectX (and thus DirectInput) driver not functional when using an
+      OpenGL SDL_Surface.
+
+    * DirectX (and thus DirectInput) driver not functional in windowed mode.
+
+    * Mouse buttons 4-7 unusable with the DirectX driver due to DirectInput 5
+      not exposing the required functionality. Use DirectInput 7 instead.
+
+    * Low quality mouse input data when using the windib driver due to use of
+      WM_MOUSEMOVE events. Use GetCursorPos API call instead.
+
+  The patch can be found in misc/sdl-win32-mouse-fixes.diff.
+
 PNG support
   ioquake3 supports the use of PNG (Portable Network Graphic) images as
   textures. It should be noted that the use of such images in a map will
@@ -417,16 +439,14 @@ PNG support
 Please send all patches to bugzilla (https://bugzilla.icculus.org), or join the
 mailing list (quake3-subscribe@icculus.org) and submit your patch there.  The
 best case scenario is that you submit your patch to bugzilla, and then post the
-URL to the mailing list. If you're too lazy for either method, then it would be
-better if you emailed your patches to zachary@ioquake.org directly than not at
-all.
-
-The focus for ioquake3 to develop a stable base suitable for further
-development, and provide players with the same Quake 3 experience they've had
-for years. As such ioq3 does not have any significant graphical enhancements
-and none are planned at this time. However, improved graphics and sound
-patches will be accepted as long as they are entirely optional, do not
-require new media and are off by default.
+URL to the mailing list.
+
+The focus for ioq3 is to develop a stable base suitable for further development
+and provide players with the same Quake 3 experience they've had for years. As
+such ioq3 does not have any significant graphical enhancements and none are
+planned at this time. However, improved graphics and sound patches will be
+accepted as long as they are entirely optional, do not require new media and
+are off by default.
 
 
 --------------------------------------------- Building Official Installers -----
@@ -450,16 +470,12 @@ but we have some general guidelines:
     providing pak0.pk3 and the patch pk3s are not refered to or included in the
     installer.
 
-  * Please include at least an SDL so/dylib on every platform.
+  * Please include at least an SDL so/dylib/dll on every platform.
 
   * Please include an OpenAL so/dylib/dll, since every platform should be using
     it by now.
 
-  * We'll bump the version to 1.34 as soon as we get enough people who can
-    demonstrate a competent build for Windows and Mac.
-
-  * Please contact the mailing list and/or zakk@timedoctor.org after you've
-    made your installer.
+  * Please contact the mailing list when you've made your installer.
 
   * Please be prepared to alter your installer on the whim of the maintainers.
 
